/* BASiC iNPUT/OUTPUT help to convert LiNUX->DOS 
 * LiNUX VERSION OF THE BASIC SCREEN ROUTiNES
 */
#include<ncurses.h>

#ifdef __FreeBSD__
#include <string.h>
#include <sys/ioctl.h>
#include <sys/kbio.h>
#include <unistd.h>
keymap_t orig_kmap;
fkeyarg_t orig_fkeys[64];
#endif

#define write printw
#define writechar addch

void TextColor(int color) {
   static char oldcolor=99;
   char fore,back;
   if (color!=oldcolor)  {
      fore=color&7;
      back=(color&112)>>1;
      if ((color&8)==8) attrset(A_BOLD); else  attrset(A_NORMAL);
      if ((color&128)==128) attron(A_BLINK);
      if (fore==0&&back==0)
        color_set(64,NULL);
        /* attron((attr_t)COLOR_PAIR(64)); */
      else
        color_set((fore+back),NULL);
        /* attron((attr_t)COLOR_PAIR(fore+back)); */
      oldcolor=color;
   }
}


int colortab(int a) /* convert LiNUX Color code to DOS-standard */{
   switch(a) {
    case 0 : return COLOR_BLACK;
    case 1 : return COLOR_BLUE;
    case 2 : return COLOR_GREEN;
    case 3 : return COLOR_CYAN;
    case 4 : return COLOR_RED;
    case 5 : return COLOR_MAGENTA;
    case 6 : return COLOR_YELLOW;
    case 7 : return COLOR_WHITE;
   }
}

void init_bio_crt() {
   int x,y;
#ifdef __FreeBSD__
   keymap_t kmap;
   fkeyarg_t fkey;
   char  name[256];
   char  term[256];
#endif

   printf("\e(U");
   initscr();
   if(!has_colors()) {	   
      endwin();
      fprintf(stderr, "\ncolor not supported \n");
      exit(1);
   }
   start_color();
   scrollok(stdscr, FALSE);
   meta(stdscr, TRUE);
   nocbreak();
   noecho();
   keypad(stdscr, TRUE);
   nodelay(stdscr, TRUE);
   nonl();
   raw();
   ESCDELAY=50;
   COLORS=64;
   for (x = 1; x < 65; x++) {
      init_pair(x, colortab(x % 8),colortab(x / 8));
   }
#ifdef __FreeBSD__
   strncpy(name,ttyname(STDIN_FILENO),255);
   if(name[8]=='v'){
      /*******************************
      * Set up ALT keymappings here. *
      ********************************/
      /* get Current KeyMap */
      ioctl(0,GIO_KEYMAP,&kmap);
      memcpy(&orig_kmap,&kmap,sizeof(kmap));
      /* Set Number Keys */
      kmap.key[2].map[4] = 177;
      kmap.key[3].map[4] = 178;
      kmap.key[4].map[4] = 179;
      kmap.key[5].map[4] = 180;
      kmap.key[6].map[4] = 181;
      kmap.key[7].map[4] = 182;
      kmap.key[8].map[4] = 183;
      kmap.key[9].map[4] = 184;
      kmap.key[10].map[4] = 185;
      kmap.key[11].map[4] = 186;

      /* Set top row */
      kmap.key[16].map[4] = 241;
      kmap.key[17].map[4] = 247;
      kmap.key[18].map[4] = 229;
      kmap.key[19].map[4] = 242;
      kmap.key[20].map[4] = 244;
      kmap.key[21].map[4] = 249;
      kmap.key[22].map[4] = 245;
      kmap.key[23].map[4] = 233;
      kmap.key[24].map[4] = 239;
      kmap.key[25].map[4] = 240;
      kmap.key[16].map[5] = 241;
      kmap.key[17].map[5] = 247;
      kmap.key[18].map[5] = 229;
      kmap.key[19].map[5] = 242;
      kmap.key[20].map[5] = 244;
      kmap.key[21].map[5] = 249;
      kmap.key[22].map[5] = 245;
      kmap.key[23].map[5] = 233;
      kmap.key[24].map[5] = 239;
      kmap.key[25].map[5] = 240;

      /* Set middle row */
      kmap.key[30].map[4] = 225;
      kmap.key[31].map[4] = 243;
      kmap.key[32].map[4] = 228;
      kmap.key[33].map[4] = 230;
      kmap.key[34].map[4] = 231;
      kmap.key[35].map[4] = 232;
      kmap.key[36].map[4] = 234;
      kmap.key[37].map[4] = 235;
      kmap.key[38].map[4] = 236;
      kmap.key[30].map[5] = 225;
      kmap.key[31].map[5] = 243;
      kmap.key[32].map[5] = 228;
      kmap.key[33].map[5] = 230;
      kmap.key[34].map[5] = 231;
      kmap.key[35].map[5] = 232;
      kmap.key[36].map[5] = 234;
      kmap.key[37].map[5] = 235;
      kmap.key[38].map[5] = 236;

      /* Set bottom row */
      kmap.key[44].map[4] = 250;
      kmap.key[45].map[4] = 248;
      kmap.key[46].map[4] = 227;
      kmap.key[47].map[4] = 246;
      kmap.key[48].map[4] = 226;
      kmap.key[49].map[4] = 238;
      kmap.key[50].map[4] = 237;
      kmap.key[44].map[5] = 250;
      kmap.key[45].map[5] = 248;
      kmap.key[46].map[5] = 227;
      kmap.key[47].map[5] = 246;
      kmap.key[48].map[5] = 226;
      kmap.key[49].map[5] = 238;
      kmap.key[50].map[5] = 237;
   
      /* Set CTRL-<arrow> */
      kmap.key[95].map[2]=F(23);
      kmap.key[97].map[2]=F(24);
      kmap.key[98].map[2]=F(25);
      kmap.key[100].map[2]=F(26);
      kmap.key[72].map[2]=F(23);
      kmap.key[75].map[2]=F(24);
      kmap.key[77].map[2]=F(25);
      kmap.key[80].map[2]=F(26);

      ioctl(0,PIO_KEYMAP,&kmap);

      /* Set Kludge F-Keys for SHIFT-Fx -> CTRL-x map */
      for(x=12;x<=25;x++){
	     fkey.keynum=x;
	     ioctl(0,GETFKEY,&fkey);
	     memcpy(&orig_fkeys[x],&fkey,sizeof(fkey));
	     bzero(&fkey.keydef,MAXFK);
	     switch(x){
	        case 12:
      	       fkey.keydef[0]=17;
			   break;
	        case 13:
      	       fkey.keydef[0]=23;
			   break;
	        case 14:
      	       fkey.keydef[0]=5;
			break;
	        case 15:
      	       fkey.keydef[0]=18;
			   break;
	        case 16:
      	       fkey.keydef[0]=20;
			   break;
	        case 17:
      	       fkey.keydef[0]=25;
			   break;
	        case 18:
      	       fkey.keydef[0]=21;
			   break;
	        case 19:
      	       fkey.keydef[0]=9;
			   break;
	        case 20:
      	       fkey.keydef[0]=15;
			   break;
	        case 21:
      	       fkey.keydef[0]=16;
			   break;
	        case 22:
      	       fkey.keydef[0]=4;
			   break;
	        case 23:
      	       fkey.keydef[0]=26;
			   break;
	        case 24:
      	       fkey.keydef[0]=3;
			   break;
	        case 25:
      	       fkey.keydef[0]=1;
			   break;
         }
	     fkey.flen=1;
	     ioctl(0,SETFKEY,&fkey);
      }
   }
   else  {
   }
#endif
}

void exit_bio_crt() {
   int x;

   endwin();
#ifdef __FreeBSD__
   ioctl(0,PIO_KEYMAP,&orig_kmap);
   for(x=12;x<=25;x++)
      ioctl(0,SETFKEY,&orig_fkeys[x]);
#endif
}
